var canvas;
var cntx;
var cnvBackBuffer;
var cntxBackBuffer;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    
    showAppTitle();
    initialValues();
    initialiseGUI();
    initialiseEvents();
    CheckButtons();
    drawBasicScreen();
}
      
function initialiseEvents(){
    $("#visualisation").on("mousedown touchstart",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseDown();
    });
    
    $("#visualisation").on("mousemove touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove();
    });
    
    $("#visualisation").on("mouseup touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp();
    });
    
    $("#noToConvert").on("input propertychange paste", function(){
        var txt="";
        if($("#noToConvert").val()==""){
            $("#convert").prop("disabled",true);
            prompt="Πληκτρολόγησε έναν αριθμό μέσα στο λευκό πλαίσιο";
        }
        else {
            //Καθαρισμός byte
            for(var i=0;i<NoOfBits;i++){
                bits[i]=0;
            }
            $("#convert").prop("disabled",false);
            prompt="Πάτησε το κουμπί [Μετατροπή]";
        }
        //Αποκοπή παραπανίσιων χαρακτήρων
        txt=$("#noToConvert").val();
        if(txt.length>3){
            txt=txt.substring(0,3); 
            $("#noToConvert").val(txt);
            $("#noToConvert").setSelectionRange(3,3);
        }
        if(NumberOK($("#noToConvert").val())){
            $("#noToConvert").css("color","#0000ff");
            $("#noToConvert").css("background-color","#ffffff");
            $("#convert").prop("disabled",false);
        }
        else{
            //Εμφάνιση δυαδικής αναπαράστασης
            $("#noToConvert").css("color","#ffffff");
            $("#noToConvert").css("background-color","#ff0000");
            $("#convert").prop("disabled",true);
            prompt="ΠΡΟΣΟΧΗ! πρέπει να εισαχθεί ακέραιος στο διάστημα [0 , 255].";
        }
        drawBasicScreen();
    });
    
    $("input[type=radio][name=methodSlctr]").change(function(){
        if(this.value=="1"){
            CurrentVersion=V1;
        }
        else if(this.value=="2"){
            CurrentVersion=V2;
        }
        else if(this.value=="3"){
            CurrentVersion=V3;
            //simSpeed=20;
        }
        //HscrFrameRate.setValue(framerate);
        prompt="";
        drawBasicScreen();
    });
} 

function initialiseGUI(){
    $("#noToConvert").val("");
    if(TwoVersionsOnly){
        $("#method1").hide();
        $("#mthd1Caption").hide();
        //$("#mthd2Caption").html(" Πρώτη μέθοδος");
        //$("#mthd3Caption").html(" Δεύτερη μέθοδος");
        $("#method2").prop("checked",true);
        $("#method2").prop("disabled",false);
        $("#method3").prop("disabled",true);
    }
    else{
        $("#method1").prop("checked",true);
        $("#method2").prop("disabled",true);
        $("#method3").prop("disabled",true);
    }
    $("#convert").prop("disabled",true);
}

function initialValues(){
    $("#frameRate").val(5);
    if (TwoVersionsOnly){
        CurrentVersion=V2;
    }
    else{
        CurrentVersion=V1;  
    }    
    DecimalValueColor=BackR;
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgLogo=document.getElementById("Logo");
    width=canvas.width;
    height=canvas.height;
    ByteTop=height/2;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-5;
    logoTop=BottomPanelTop+(BottomPanelHeight-logoHeight)/2;

    //ByteTop=35*height/100;
    ByteLeft=(width-(NoOfDigitsPerPlaceHolder*BitWidth+2*BitBorder)*NoOfBits)/2;
    for(var i=0;i<NoOfBits;i++){
        bits[i]=0;
    }

}

function drawBasicScreen(){
    cntx.clearRect(0,0,canvas.width,canvas.height);
    
    drawFrames();
    drawLogoImage();
    
    var promptYCoord=BottomPanelTop+25;
    var promptColor=LetterColor;
    //prompt="Κάνε κλικ στα ψηφία για να αλλάξεις την τιμή τους.";
    cnvsWrite(promptColor,fontSize-6,"Arial",-1,promptYCoord,prompt);
    promptYCoord+=28;

    DrawBytePlaceHolder();
    DrawByte();
    if(Math.abs(CurrentState)>=stateMoveFactorsX)DrawFactors();
    if(Math.abs(CurrentState)>=stateFadeInNo)DrawDecimalValue();
}

function drawFrames(){
    cntx.fillStyle="white";
    cntx.strokeStyle="black";
    cntx.beginPath();
    //Περιοχή σχεδίασης
    cntx.fillRect(0,TopPanelHeight,width,height-TopPanelHeight-BottomPanelHeight);
    //πλαίσιο καμβά
    cntx.rect(0,0,width,height);
    //άνω πλαίσιο
    cntx.rect(0,0,width,TopPanelHeight);
    //κάτω πλαίσιο
    cntx.rect(0,BottomPanelTop,width,BottomPanelHeight);

    cntx.stroke();
    cnvsWrite(LetterColor,32,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
}

function drawLogoImage(){
    cntx.drawImage(imgLogo,logoLeft,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    cntx.font=fontSize+"px "+fontName;
    cntx.fillStyle=clr;
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseDown(){
    drawBasicScreen();
}

function handleMouseMove(){
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else{
        imgLogo=document.getElementById("Logo");
    }
    if (MouseOverByte()){
        SelBit=parseInt((mx-ByteLeft)/(NoOfDigitsPerPlaceHolder*BitWidth));
    }
    else{
        SelBit=-1;
    }
    drawBasicScreen();
    //console.log("mx="+mx+" , my="+my+" ,infoSwitchHover="+infoSwitchHover+" ,coordSwitchHover="+coordSwitchHover);
}

function handleMouseUp(){
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight) {
        showHTML();
    }
    if(SelBit>=0 && CurrentState==stateWaitingForInput) {
        $("#noToConvert").val("");
        bits[SelBit]=(1-bits[SelBit]);
        CheckButtons();
        $("#convert").prop("disabled",true);
        $("#pauseContinue").prop("disabled",true);
    }       
    drawBasicScreen();
}

function Dec2Bin(sum){
    for(var i=0;i<NoOfBits;i++){
        bits[NoOfBits-1-i]=sum % 2;
        sum=parseInt(sum/2);
    }
}

function MouseOverByte(){
    if(mx>=ByteLeft && mx<=ByteLeft+NoOfDigitsPerPlaceHolder*NoOfBits*BitWidth+BitBorder && my<=ByteTop-BitBorder && my>=ByteTop-BitBorder-fontSize){
        return true;
    }
    else{
        return false;
    }
}

function DrawByte(){
    var X1,X2,msgWidth;
    var message;
    var bitColor="rgb(0,0,0)";
    for(var i=0;i<NoOfBits;i++){
        X1=ByteLeft+NoOfDigitsPerPlaceHolder*i*BitWidth+BitBorder;
        X2=ByteLeft+NoOfDigitsPerPlaceHolder*(i+1)*BitWidth-BitBorder;
        message=""+bits[i];
        msgWidth=cntx.measureText(message).width;
        if(CurrentVersion==V3){
            if(i<FillingBit+1){
                bitColor="rgb(0,0,0)";
            }
            else{
                bitColor="rgb(0,0,255)";
            }
        }
        else{
            if(i==SelBit){
                bitColor="rgb(0,255,255)";
            }
            else{
                bitColor="rgb(0,0,0)";
            }
        }
        cnvsWrite(bitColor,fontSize,"Arial",parseInt((X2-X1-msgWidth)/2)+X1,ByteTop-BitBorder,message);
    }
}

function DrawByte2(){
    var X1,X2,msgWidth;
    var message;
    var bitColor="rgb(0,0,0)";
    for(var i=0;i<NoOfBits;i++){
        X1=ByteLeft+NoOfDigitsPerPlaceHolder*i*BitWidth+BitBorder;
        X2=ByteLeft+NoOfDigitsPerPlaceHolder*(i+1)*BitWidth-BitBorder;
        message=""+bits[i];
        msgWidth=cntx.measureText(message).width;
        if(i==SelBit){
            bitColor="rgb(0,215,255)";
        }
        else{
            bitColor="rgb(0,0,0)";
        }
        cnvsWrite(bitColor,fontSize,"Arial",parseInt((X2-X1-msgWidth)/2)+X1,ByteTop-BitBorder,message);
    }
}

function DrawBytePlaceHolder(){
    var X1,X2,msgWidth,value,sum=0;
    var ColOn="rgb(0,0,255)";
    var ColOff="rgb(255,0,0)";
    var bitColor="rgb(0,0,0)";
    var message;
    //Σχεδίαση θέσεων
    cntx.beginPath();
    for(var i=0;i<NoOfBits;i++){
        X1=ByteLeft+NoOfDigitsPerPlaceHolder*i*BitWidth+BitBorder;
        X2=ByteLeft+NoOfDigitsPerPlaceHolder*(i+1)*BitWidth-BitBorder;
        cntx.moveTo(X1,ByteTop);
        cntx.lineTo(X2,ByteTop);
        
        cntx.moveTo(X1,ByteTop);
        cntx.lineTo(X1,ByteTop-BitBorder);
        
        cntx.moveTo(X2,ByteTop);
        cntx.lineTo(X2,ByteTop-BitBorder);
        value=parseInt(Math.pow(2,NoOfBits-i-1));
        message=""+value;
        msgWidth=cntx.measureText(message).width;
        //Σχεδίαση αξίας θέσης
        if(bits[i]==0){
            bitColor=ColOff;
        }
        else{
            bitColor=ColOn;
        }
        cnvsWrite(bitColor,fontSize,"Arial",parseInt((X2-X1-msgWidth)/2)+X1,ByteTop+8*BitBorder,message);
        if($("#noToConvert").val()=="" && CurrentState==stateWaitingForInput){
            bitColor="rgb(0,0,0)";
            value=value*bits[i];
            message=""+value;
            msgWidth=cntx.measureText(message).width;
            sum=sum+value;
            cnvsWrite(bitColor,fontSize,"Arial",parseInt((X2-X1-msgWidth)/2)+X1,ByteTop+20*BitBorder,message);
            if(i<NoOfBits-1){
                message="+";
                msgWidth=cntx.measureText(message).width;
                X1=ByteLeft+NoOfDigitsPerPlaceHolder*(i+1)*BitWidth-BitBorder;
                X2=ByteLeft+NoOfDigitsPerPlaceHolder*(i+1)*BitWidth+BitBorder;
                cnvsWrite(bitColor,fontSize,"Arial",parseInt((X2-X1-msgWidth)/2)+X1,ByteTop+20*BitBorder,message);
            }
        }
    }
    if($("#noToConvert").val()=="" && CurrentState==stateWaitingForInput){
        X2=ByteLeft+NoOfDigitsPerPlaceHolder*NoOfBits*BitWidth+BitBorder;
        cnvsWrite(bitColor,fontSize,"Arial",X2,ByteTop+20*BitBorder,"= "+sum);
    }
    cntx.stroke();
}

/*function DrawBytePlaceHolder2(){
    var X1,X2,msgWidth,value,sum=0;
    var message;
    var bitColor=0;
    //Σχεδίαση θέσεων
    cntx.strokeStyle=FactorsColor;
    cntx.beginPath();
    for(var i=0;i<NoOfBits;i++){
        X1=ByteLeft+NoOfDigitsPerPlaceHolder*i*BitWidth+BitBorder;
        X2=ByteLeft+NoOfDigitsPerPlaceHolder*(i+1)*BitWidth-BitBorder;
        cntx.moveTo(X1,ByteTop);
        cntx.lineTo(X2,ByteTop);
        
        cntx.moveTo(X1,ByteTop);
        cntx.lineTo(X1,ByteTop-BitBorder);
        
        cntx.moveTo(X2,ByteTop);
        cntx.lineTo(X2,ByteTop-BitBorder);
        value=parseInt(Math.pow(2,NoOfBits-i-1));
        message=""+value;
        msgWidth=cntx.measureText(message).width;
        //Σχεδίαση αξίας θέσης
        if(bits[i]==0){
            bitColor=ColOff;
        }
        else{
            bitColor=ColOn;
        }
        cnvsWrite(bitColor,fontSize,"Arial",parseInt((X2-X1-msgWidth)/2)+X1,ByteTop+8*BitBorder,message);

        value=value*bits[i];
        message=""+value;
        msgWidth=cntx.measureText(message).width;
        sum=sum+value;
        cnvsWrite(bitColor,fontSize,"Arial",parseInt((X2-X1-msgWidth)/2)+X1,ByteTop+20*BitBorder,message);
        if(i<NoOfBits-1){
            message="+";
            msgWidth=cntx.measureText(message).width;
            X1=ByteLeft+NoOfDigitsPerPlaceHolder*(i+1)*BitWidth-BitBorder;
            X2=ByteLeft+NoOfDigitsPerPlaceHolder*(i+1)*BitWidth+BitBorder;
            cnvsWrite(bitColor,fontSize,"Arial",parseInt((X2-X1-msgWidth)/2)+X1,ByteTop+20*BitBorder,message);
        }
    }
    cntx.stroke();
    X2=ByteLeft+NoOfDigitsPerPlaceHolder*NoOfBits*BitWidth+BitBorder;
    cnvsWrite(ColOn,fontSize,"Arial",X2,ByteTop+20*BitBorder,"= "+sum);
}*/

function CheckButtons(){
    var sum=CalculateSum();
    if(sum==255){
        $("#increment").prop("disabled",true);
    }
    else{
        $("#increment").prop("disabled",false);
    }
    if(sum==0){
        $("#decrement").prop("disabled",true);
    }
    else{
        $("#decrement").prop("disabled",false);
    }
}

function CalculateSum(){
    var sum=0;
    for(var i=0;i<NoOfBits;i++){
        sum=sum+parseInt(Math.pow(2,NoOfBits-i-1)*bits[i]);
    }
    return sum;
}

function actionPerformed(btnSlctr){
    var sum=CalculateSum();
    if(btnSlctr==0){
        sum++;
        Dec2Bin(sum);
        CheckButtons();             
    }
    else if(btnSlctr==1){
        sum--;
        Dec2Bin(sum);
        CheckButtons();             
    }
    else if(btnSlctr==2){
        sum=0;
        Dec2Bin(sum);
        CheckButtons();
    }
    else if(btnSlctr==3){
        DecimalValueR=0;
        DecimalValueG=0;
        DecimalValueB=0;
        prompt="";
        $("#convert").prop("disabled",true);
        $("#increment").prop("disabled",true);
        $("#decrement").prop("disabled",true);
        $("#decrement").prop("disabled",true);
        $("#allZero").prop("disabled",true);
        for(var i=0;i<NoOfBits;i++) bits[i]=0;
        CurrentState=stateFadeInNo;
        DecimalValueColor=BackR;
        if(CurrentVersion==V1){
            FactorColor=BackR;
        }
        else {
            FactorColor=0;
            if(CurrentVersion==V3) FillingBit=NoOfBits-1;
        }
        $("#pauseContinue").prop("disabled",false);
        simSpeed=5*$("#frameRate").val();
        timerLoop=setInterval(
                function(){
                    $("#convert").prop("disabled",true);
                    $(".methodSlctr").prop("disabled",true);
                    $("#frameRate").prop("disabled",true);
                    //$(".methodSlctr input:radio").attr("disabled",true);
                    run();
                },
                simSpeed);
        
    }
    else if(btnSlctr==4){
        if(CurrentState<0){
            $("#pauseContinue").text("Συνέχεια");
        }
        else{
            $("#pauseContinue").text("Παύση");
        }
        CurrentState=-CurrentState;
    }
    drawBasicScreen();
}


function run(){
    //while(true){
        if(CurrentState==stateWaitingForInput){
            $("#pauseContinue").prop("disabled",true);
        }
        if(CurrentState==stateFadeInNo){
            HandleFadeIn();
        }
        else if(CurrentState==stateGenerateFactors){
            GenerateFactors();
        }
        else if(CurrentState==stateMoveFactorsX){
            if(CurrentVersion==V1){
                MoveFactors();
            }
            else if(CurrentVersion==V2){
                MoveDecimal();
            }
        }
        else if(CurrentState==stateFinaliseFactorsXPosition){
            FinaliseFactorsPosition();
        }
        else if(CurrentState==stateMoveFactorsY){
            MoveFactorsY();
        }
        else if(CurrentState==stateFinaliseFactorsYPosition){
            FinaliseFactorsYPosition();
        }
        else if(CurrentState==stateFillBits){
            FillBits();
        }
        else if(CurrentState==statePerformDivision){
            PerformDivision();
        }
        else if(CurrentState==stateMoveRemainder){
            MoveRemainder();                
        }
        else if(CurrentState==stateMoveQuotient){
            MoveQuotient();
        }
        drawBasicScreen();
    //}
}

function HandleFadeIn(){
    DecimalValueColor=DecimalValueColor-3;
    if(DecimalValueColor<90) {
        DecimalValueColor=0;
        if(CurrentVersion==V3){
            CurrentState=statePerformDivision;
        }
        else{
            CurrentState=stateGenerateFactors;
        }
    }
}

function GenerateFactors(){
    var x,i,j,X1,X2,msgWidth;
    var message;
    if($("#noToConvert").val()==""){
        x=0;
    }
    else{
        x=parseInt($("#noToConvert").val());
    }       
    for(i=0;i<NoOfBits;i++){
        //Υπολογισμός bit
        j=NoOfBits-i-1;
        Auxbits[j]=(x % 2);
        //Υπολογισμός Παράγοντα
        Factors[j]=(Math.pow(2,i)*Auxbits[j]);
        //Αρχική x-συντεταγμένη παράγοντα
        FactorsXcoord[j]=DecimalValueXcoord;
        FactorsYcoord[j]=DecimalValueYcoord;
        //Υπολογισμός μεγέθους του βήματος
        X1=ByteLeft+NoOfDigitsPerPlaceHolder*j*BitWidth+BitBorder;
        X2=ByteLeft+NoOfDigitsPerPlaceHolder*(j+1)*BitWidth-BitBorder;
        message=""+Factors[j];
        msgWidth=cntx.measureText(message).width;
        FactorsFinalXcoord[j]=(X2-X1-msgWidth)/2+X1;
        //Επόμενο bit
        x=parseInt(x/2);
    }
    for(i=0;i<NoOfBits;i++){
        if(Factors[i]>0){
            FactorsFinalYcoord[i]=ByteTop+8*BitBorder;
        }
        else{
            FactorsFinalYcoord[i]=DecimalValueYcoord;
        }
        FactorsXstep[i]=parseInt((FactorsFinalXcoord[i]-DecimalValueXcoord)/NoOfSteps);
        if(FactorsXstep[i]<1) FactorsXstep[i]=1;
        if(Math.abs(FactorsXstep[i])<1)FactorsXstep[i]=Math.sign(FactorsXstep[i]);
        FactorsYstep[i]=parseInt((FactorsFinalYcoord[i]-DecimalValueYcoord)/NoOfYSteps);
        if(Math.abs(FactorsYstep[i])>-1)FactorsYstep[i]=Math.sign(FactorsYstep[i]);
    }
    CurrentState=stateMoveFactorsX;
}

function MoveFactors(){
    var ReadyForNextState=true;
    for(var i=0;i<NoOfBits;i++){
        FactorsXcoord[i]=parseInt(FactorsXcoord[i]+FactorsXstep[i]);
        if(FactorsXcoord[i]>FactorsFinalXcoord[i]){
            FactorsXcoord[i]=FactorsFinalXcoord[i];
        }
        else{
            ReadyForNextState=false;
        }
    }
    FactorColor=FactorColor-parseInt(255/NoOfSteps);
    if(FactorColor<0){
        FactorColor=0;
        if(ReadyForNextState)CurrentState=stateFinaliseFactorsXPosition;
    }
}

function MoveDecimal(){
    DecimalValueXcoord=parseInt(DecimalValueXcoord+FactorsXstep[7]);
    TraversingBit=parseInt((DecimalValueXcoord-InitialDecimalValueXcoord)/(NoOfDigitsPerPlaceHolder*BitWidth))-1;
    if(TraversingBit<0){
        TraversingBit=0;
    }
    else if(TraversingBit>7){
        CurrentState=stateFinaliseFactorsXPosition;
        TraversingBit=7;
    }
    if(TraversingBit>=0 && Factors[TraversingBit]<=DecimalValue && FactorsFinalXcoord[TraversingBit]<=DecimalValueXcoord){
        DecimalValue=DecimalValue-Factors[TraversingBit];
    }
}

function FinaliseFactorsPosition(){
    for(var i=0;i<NoOfBits;i++){
        FactorsXcoord[i]=FactorsFinalXcoord[i];
    }
    CurrentState=stateMoveFactorsY;
}

function FinaliseFactorsYPosition(){
    for(var i=0;i<NoOfBits;i++){
        FactorsYcoord[i]=FactorsFinalYcoord[i];
    }       
    CurrentState=stateFillBits;
}

function MoveFactorsY(){
    var done=false,NoMovement=true;         
    for(var i=0;i<NoOfBits;i++){
        if(FactorsYstep[i]!=0) NoMovement=false;
        FactorsYcoord[i]=parseInt(FactorsYcoord[i]+FactorsYstep[i]);
        if(FactorsYcoord[i]<FactorsFinalYcoord[i]){
            FactorsYcoord[i]=FactorsFinalYcoord[i];
            done=true;
        }
    }
    if(done || NoMovement) CurrentState=stateFinaliseFactorsYPosition;
}

function FinaliseFactorsYPosition(){
    for(var i=0;i<NoOfBits;i++){
        FactorsYcoord[i]=FactorsFinalYcoord[i];
    }       
    CurrentState=stateFillBits;
}

function FillBits(){
    for(var i=0;i<NoOfBits;i++){
        bits[i]=Auxbits[i];
    }
    CurrentState=stateWaitingForInput;
    prompt="";
    if(CurrentVersion==V1 && prompt1On){
        //@@@@@@@@
        $("#method2").prop("disabled",false);
        //@@@@@@@@
        if(TwoVersionsOnly)
          prompt="";
        else
          prompt="Για να καταλάβεις πως υπολογίζονται οι παράγοντες, μπορείς να δοκιμάσεις τη δεύτερη μέθοδο.";
        prompt1On=false;
    }
    if(CurrentVersion==V2 && prompt2On){
        $("#method3").prop("disabled",false);
        if(TwoVersionsOnly){
            prompt="";
        }
        else{
            prompt="Για μια πιο μαθηματικοποιημένη τεχνική μετατροπής, μπορείς να δοκιμάσεις την τρίτη μέθοδο.";
        }
        prompt2On=false;
    }
    $("#convert").prop("disabled",false);
    $("#allZero").prop("disabled",false);
    CheckButtons();
    clearInterval(timerLoop);
    $("#convert").prop("disabled",false);
    $(".methodSlctr").prop("disabled",false);
    $("#frameRate").prop("disabled",false);
    //$(".methodSlctr input:radio").attr("disabled",true);
}

function PerformDivision(){
    Quotient=parseInt(DecimalValue/2);
    Remainder=DecimalValue % 2;
    RemainderXcoord=DivisionLinesX-cntx.measureText(""+Remainder).width-2;
    RemainderYcoord=DecimalValueYcoord+fontSize;
    QuotientXcoord=DivisionLinesX+3;
    QuotientYcoord=DecimalValueYcoord+fontSize;
    CurrentState=stateMoveRemainder;
}


function MoveRemainder(){
    var X1=ByteLeft+NoOfDigitsPerPlaceHolder*FillingBit*BitWidth-BitBorder;
    var X2=ByteLeft+NoOfDigitsPerPlaceHolder*(FillingBit+1)*BitWidth-BitBorder;
    var msgWidth=cntx.measureText(""+Remainder).width;
    var X=parseInt((X2-X1-msgWidth)/2)+X1;
    if(RemainderXcoord<X){
        RemainderXcoord=RemainderXcoord+5;
    }
    else{
        RemainderXcoord=X;
        if(RemainderYcoord<ByteTop-BitBorder){
            RemainderYcoord=RemainderYcoord+1;
        }
        else{
            RemainderYcoord=ByteTop-BitBorder;
            bits[FillingBit]=Remainder;
            FillingBit=FillingBit-1;
            if(Quotient>0){
                CurrentState=stateMoveQuotient;
                QuotientDirection=1;
            }
            else{
                CurrentState=stateWaitingForInput;
                CheckButtons();
                clearInterval(timerLoop);
                $("#convert").prop("disabled",false);
                $(".methodSlctr").prop("disabled",false);
                $("#frameRate").prop("disabled",false);
                drawBasicScreen();
            }               
        }
    }
}

function MoveQuotient(){
    if(DiagonalMove){
        MoveQuotientDiagonally();
    }
    else{
        MoveQuotientInStraightLines();
    }
}

function MoveQuotientDiagonally(){
    var PixelStep=1;
    var FinishedX=false,FinishedY=false;
    var FinalXcoord=DivisionLinesX-cntx.measureText(""+Quotient).width-BitBorder;
    if(QuotientXcoord>FinalXcoord){
        QuotientXcoord=QuotientXcoord-PixelStep;
    }
    else{
        QuotientXcoord=FinalXcoord;
        FinishedX=true;
    }
    if(QuotientYcoord>DecimalValueYcoord){
        QuotientYcoord=QuotientYcoord-PixelStep;
        DecimalValueR=parseInt(-255*(QuotientYcoord-DecimalValueYcoord)/fontSize+255);
        DecimalValueG=DecimalValueR;
        DecimalValueB=DecimalValueR;
    }
    else{
        QuotientYcoord=DecimalValueYcoord;
        FinishedY=true;
    }
    if(FinishedX && FinishedY) {
        DecimalValueR=0;
        DecimalValueG=0;
        DecimalValueB=0;
        DecimalValue=Quotient;
        DecimalValueXcoord=QuotientXcoord;
        $("#convert").prop("disabled",false);
        CurrentState=statePerformDivision;
    }
}

function MoveQuotientInStraightLines(){
    var PixelStep=1;
    if(QuotientDirection==1){
        if(QuotientXcoord<DivisionLinesX+cntx.measureText(""+Quotient).width+2){
            QuotientXcoord=QuotientXcoord+PixelStep;
        }
        else{
            QuotientXcoord=DivisionLinesX+cntx.measureText(""+Quotient).width+2;
            QuotientDirection=2;
        }
    }
    else if(QuotientDirection==2){
        if(QuotientYcoord>DivisionLinesY-fontSize/2){
            QuotientYcoord=QuotientYcoord-PixelStep;
        }
        else{
            QuotientYcoord=DivisionLinesY-fontSize/2;
            QuotientDirection=3;
        }
    }
    else if(QuotientDirection==3){
        if(QuotientXcoord+cntx.measureText(""+Quotient).width+BitBorder>DivisionLinesX){
            QuotientXcoord=QuotientXcoord-PixelStep;
        }
        else{
            QuotientXcoord=DivisionLinesX-cntx.measureText(""+Quotient).width-BitBorder;
            QuotientDirection=4;
        }
    }
    else if(QuotientDirection==4){
        if(QuotientYcoord<DecimalValueYcoord){                 
            QuotientYcoord=QuotientYcoord+PixelStep;
            DecimalValueR=parseInt(-255/(DecimalValueYcoord-(DivisionLinesY-fontSize/2))*(DecimalValueYcoord-QuotientYcoord))+255;
            DecimalValueG=DecimalValueR;
            DecimalValueB=DecimalValueR;
        }
        else{
            DecimalValueR=0;
            DecimalValueG=0;
            DecimalValueB=0;
            QuotientYcoord=DecimalValueYcoord;
            QuotientDirection=1;
            DecimalValue=Quotient;
            DecimalValueXcoord=QuotientXcoord;
            $("#convert").prop("disabled",false);
            CurrentState=statePerformDivision;
        }
    }
}

function NumberOK(No){
    var sum=0;
    var Flag=true;
    var digit;
    for(var i=0;i<No.length;i++){
        digit=No.charAt(i);
        if(digit<"0" || digit>"9") {
            Flag=false;
        }
        else{
            sum=sum+parseInt(parseInt(digit)*Math.pow(10,No.length-i-1));
        }           
    }
    if (sum>255)Flag=false;
    return Flag;
}

function DrawFactors(){
    var MaxValue=0;
    if(CurrentVersion==V1){
        MaxValue=NoOfBits;
    }
    else if(CurrentVersion==V2){
        MaxValue=TraversingBit+1;
    }
    var fctrColor="rgb("+FactorColor+","+FactorColor+","+FactorColor+",)";
    for(var i=0;i<MaxValue;i++){
        if(CurrentVersion==V1){
            cnvsWrite(fctrColor,fontSize,"Arial",FactorsXcoord[i],FactorsYcoord[i],Factors[i]);
        }
        else if(CurrentVersion==V2 && Factors[i]!=0 && FactorsFinalXcoord[i]<DecimalValueXcoord){
            cnvsWrite(fctrColor,fontSize,"Arial",FactorsFinalXcoord[i],FactorsYcoord[i],Factors[i]);
        }
    }
}

function DrawDecimalValue(){
    var X1,X2,msgWidth;
    if($("#noToConvert").val()==""){
        DecimalValue=0;
    }
    else if(Math.abs(CurrentState)<=stateFadeInNo){
        DecimalValue=parseInt($("#noToConvert").val());
    }       
    X1=ByteLeft-NoOfDigitsPerPlaceHolder*BitWidth+BitBorder;
    X2=ByteLeft-BitBorder;
    var colorToUse="rgb(0,0,0)";
    if(CurrentVersion==V1 || CurrentVersion==V3){
        colorToUse="rgb("+DecimalValueColor+","+DecimalValueColor+","+DecimalValueColor+")";
    }
    else if(CurrentVersion==V2){
        if(Math.abs(CurrentState)>stateFadeInNo){
            if(Auxbits[TraversingBit]==0 || DecimalValue==0){
                colorToUse="rgb(255,0,0)";
            }
            else{
                colorToUse="rgb(0,0,255)";
            }
        }
        else{
            colorToUse="rgb("+DecimalValueColor+","+DecimalValueColor+","+DecimalValueColor+")";
        }
    }
    msgWidth=cntx.measureText($("#noToConvert").val()).width;
    if(Math.abs(CurrentState)<=stateFadeInNo){
        if(CurrentVersion==V3){
            DecimalValueXcoord=40;
        }
        else{
            DecimalValueXcoord=(X2-X1-msgWidth)/2+X1;
            InitialDecimalValueXcoord=DecimalValueXcoord;
        }
    }
    if(CurrentVersion==V3){
        DecimalValueYcoord=ByteTop-50;
    }
    else {
        DecimalValueYcoord=ByteTop+20*BitBorder;
    }       
    if(CurrentVersion==V3){
        colorToUse="rgb("+DecimalValueR+","+DecimalValueG+","+DecimalValueB+")";
    }
    cnvsWrite(colorToUse,fontSize,"Arial",DecimalValueXcoord,DecimalValueYcoord,DecimalValue);
    colorToUse="rgb(0,0,0)";
    if(CurrentVersion==V3){
        if(Math.abs(CurrentState)>=stateWaitingForInput){
            DivisionLinesX=DecimalValueXcoord+cntx.measureText(""+DecimalValue).width+BitBorder;
            DivisionLinesY=DecimalValueYcoord-fontSize;
            cntx.moveTo(DivisionLinesX,DivisionLinesY);
            cntx.lineTo(DivisionLinesX,DecimalValueYcoord+fontSize);
            cntx.moveTo(DivisionLinesX,DecimalValueYcoord+1);
            cntx.lineTo(DivisionLinesX+cntx.measureText("2").width+2*BitBorder,DecimalValueYcoord+1);
            cnvsWrite(colorToUse,fontSize,"Arial",DivisionLinesX+BitBorder,DecimalValueYcoord,"2");
        }
        if(Math.abs(CurrentState)==stateMoveRemainder || Math.abs(CurrentState)==stateMoveQuotient){
            if(Math.abs(CurrentState)==stateMoveRemainder){
                cnvsWrite(colorToUse,fontSize,"Arial",RemainderXcoord,RemainderYcoord,Remainder);
            }
            cnvsWrite(colorToUse,fontSize,"Arial",QuotientXcoord,QuotientYcoord,Quotient);
        }
    }
}